<template>
  <div class="container-main" ref="main">
    <div class="search-hearder" ref="topSearch">
      <el-form
        :model="queryParams"
        ref="queryForm"
        :inline="true"
        v-show="showSearch"
        label-width="auto"
      >
        <el-form-item label="单位名称" prop="name">
          <el-input
            v-model="queryParams.name"
            placeholder="请输入单位名称"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item label="联系人" prop="linkMan">
          <el-input
            v-model="queryParams.linkMan"
            placeholder="请输入联系人"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置</el-button
          >
        </el-form-item>
      </el-form>
    </div>
    <div class="layui-table-tool" ref="tableTool">
      <el-button
        type="primary"
        size="mini"
        @click="handleAdd()"
        v-hasPermi="['zongzhi:netSafetyZcUnit:add']"
        >新增</el-button
      >
      <el-button
        type="success"
        size="mini"
        :disabled="single"
        @click="handleUpdate"
        v-hasPermi="['zongzhi:netSafetyZcUnit:edit']"
        >修改</el-button
      >
      <el-button
        type="danger"
        size="mini"
        :disabled="multiple"
        @click="handleDelete"
        v-hasPermi="['zongzhi:netSafetyZcUnit:remove']"
        >删除</el-button
      >
      <el-button
        type="warning"
        size="mini"
        :loading="exportLoading"
        @click="handleExport"
        v-hasPermi="['zongzhi:netSafetyZcUnit:export']"
        >导出</el-button
      >
    </div>
    <el-table
      v-loading="loading"
      :data="netSafetyZcUnitList"
      :height="tableHeigth"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="区域" align="center" prop="areaId">
        <template slot-scope="scope">
          {{ scope.row.areaId | filterTown }}
        </template>
      </el-table-column>
      <el-table-column label="单位名称" align="center" prop="name" />
      <el-table-column label="联系人" align="center" prop="linkMan" />
      <el-table-column label="联系电话" align="center" prop="phoneNum" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="200"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            @click="handleInfo(scope.row)"
            v-hasPermi="['zongzhi:netSafetyZcUnit:list']"
          >
            查看
          </el-button>
          <el-button
            type="success"
            size="mini"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['zongzhi:netSafetyZcUnit:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="danger"
            @click="handleDelete(scope.row)"
            v-hasPermi="['zongzhi:netSafetyZcUnit:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改网络安全支持单位对话框 -->
    <el-dialog
      :visible.sync="open"
      width="1000px"
      append-to-body
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ title }}</div>
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        label-width="auto"
        class="dialog-from"
      >
        <el-row>
          <el-col :span="12">
            <el-form-item label="区域" prop="areaId">
              <el-cascader
                v-model="form.areaId"
                :options="townList"
                :props="treeProps"
                clearable
              ></el-cascader>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="单位名称" prop="name">
              <el-input v-model="form.name" placeholder="请输入单位名称" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="联系人" prop="linkMan">
              <el-input v-model="form.linkMan" placeholder="请输入联系人" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="联系电话" prop="phoneNum">
              <el-input v-model="form.phoneNum" placeholder="请输入联系电话" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--查看网络安全支持单位详情页-->
    <el-dialog
      :visible.sync="infoOpen"
      width="1000px"
      append-to-body
      :close-on-click-modal="false"
      :destroy-on-close="true"
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ infoTitle }}</div>

      <el-descriptions
        title="网络安全支持单位"
        :column="2"
        border
        labelClassName="desLable"
      >
        <el-descriptions-item label="区域">{{
          form.areaId
        }}</el-descriptions-item>

        <el-descriptions-item label="单位名称">{{
          form.name
        }}</el-descriptions-item>

        <el-descriptions-item label="联系人">{{
          form.linkMan
        }}</el-descriptions-item>

        <el-descriptions-item label="联系电话">{{
          form.phoneNum
        }}</el-descriptions-item>
      </el-descriptions>
    </el-dialog>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import {
  listNetSafetyZcUnit,
  getNetSafetyZcUnit,
  delNetSafetyZcUnit,
  addNetSafetyZcUnit,
  updateNetSafetyZcUnit,
  exportNetSafetyZcUnit,
} from "@/api/zongzhi/netZoology/netSafetyZcUnit/index.js";
export default {
  computed: {
    ...mapGetters(["townList", "treeProps"]),
  },
  name: "NetSafetyZcUnit",
  //注释字典
  data() {
    return {
      tableHeigth: 0,
      //查看详情
      infoOpen: false,
      //详情标题
      infoTitle: "",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 网络安全支持单位表格数据
      netSafetyZcUnitList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        name: null,

        linkMan: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    // //给表格一个固定值
    this.$nextTick(() => {
      this.tableHeigth =
        this.$refs.main.offsetHeight -
        (this.$refs.topSearch.offsetHeight +
          this.$refs.tableTool.offsetHeight) -
        46;
      this.getList();
    });
  },
  filters: {
    filterTown(target) {
      if (target) {
        target = JSON.parse(target);
        if (target.length > 0 && Array.isArray(target)) {
          return target.join("、");
        } else {
          return "";
        }
      }
    },
  },
  methods: {
    /** 查询网络安全支持单位列表 */
    getList() {
      this.loading = true;
      listNetSafetyZcUnit(this.queryParams).then((response) => {
        this.netSafetyZcUnitList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,

        areaId: null,

        name: null,

        linkMan: null,

        phoneNum: null,

        createId: null,

        createBy: null,

        createTime: null,

        updateId: null,

        updateBy: null,

        updateTime: null,

        remark: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /**查看按钮操作 */
    handleInfo(row) {
      this.reset();
      const id = row.id || this.ids;
      getNetSafetyZcUnit(id).then((response) => {
        response.data.areaId = JSON.parse(response.data.areaId);
        if (
          response.data.areaId.length > 0 &&
          Array.isArray(response.data.areaId)
        ) {
          response.data.areaId = response.data.areaId.join("、");
        } else {
          response.data.areaId = "";
        }
        this.form = response.data;
        this.infoOpen = true;
        this.infoTitle = "查看网络安全支持单位详情";
      });
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加网络安全支持单位";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getNetSafetyZcUnit(id).then((response) => {
        response.data.areaId = JSON.parse(response.data.areaId);
        this.form = response.data;
        this.open = true;
        this.title = "修改网络安全支持单位";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          this.form.areaId = JSON.stringify(this.form.areaId);
          if (this.form.id != null) {
            updateNetSafetyZcUnit(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addNetSafetyZcUnit(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm(
        '是否确认删除网络安全支持单位编号为"' + ids + '"的数据项?',
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(function () {
          return delNetSafetyZcUnit(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有网络安全支持单位数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.download(
            "/zongzhi/netSafetyZcUnit/export",
            {
              ...this.queryParams,
            },
            "网络安全支持单位_" + new Date().getTime() + ".xlsx"
          );
          this.exportLoading = false;
        })
        .catch(() => {});
    },
  },
};
</script>
